% recibir despacha los mensajes en orden de llegada y según su prioridad

function R = recibir (prioridad)

load variables3; % Cargamos la matriz A

load variables; % Cargamos T

ti = A(1,15); % Definimos el tiempo de entrada al sistema

tt = 1.5e-04; % Definimos el tiempo de trama

tr = ti + tt; % Inicializamos el tiempo de recepción

tc1 = ti; % Inicializamos el primer tiempo de comparación

tc2 = tc1 + T; % Inicializamos el segundo tiempo de comparación

R(size(A,1),15) = zeros; % Inicializo la matriz en la que introduciré todas las filas ordenadas

B=[]; % Definimos la matriz B, desde donde se despachan las tramas antes de colocarlas en R

b = 1; % Inicializamos b, que cuenta el número de mensajes en un intervalo

c=0; % Inicializo c, que contará la posición a partir de la que se debe seguir rellenando R


while (tc2 <= A((size(A,1)),15)) % Bucle principal

while (tc1 <= A(b,15) <= tc2)  % Bucle para buscar las tramas que se transmiten en un intervalo de tiempo
     
       
    b=b+1; % Si es así incrementamos b, hasta contar el número de mensajes en dicho intervalo
    
end

B(b,15) = zeros; % Definimos las dimensiones de B con b

for r=1:b
            
        B(r,:) =  A(r,:);      % Rellenamos B con los datos correspondientes de A
        
end

while (size(B,1)>=1)

     [x,y] = max(B(:,4));    % Obtenemos la fila con más prioridad de B
        
     B(y,15) = max(B(y,15) + tt, tr+tt); % La despachamos en B (cambiamos el tiempo de llegada por el de recepción)     
          
     c=c+1;  % Actualizamos c, que es la posicion a partir de la cual tenemos que rellenar R
        
        
        R((c),:) = B(y,:);  % Introducimos en R esta fila
                             
        B(y,:)=[]; % Borramos la fila de B      
             
        tr = R(c, 15); % Actualizamos el tiempo de recepción

end

tc1 = tc2 

tc2 = tc2 + T % Actualizamos el intervalo de comparación

b = 1; % Actualizamos b

end

% Para representar gráficamente R:

  d=[]; % Definimos el vector que portará los datos
  
  t=[]; % Definimos el vector que portará el tiempo
  
  
  for j=1:size(R,1)  % Recorremos la matriz para ir rellenando los vectores:
  
       
      if (R(j,4)==prioridad) % Se comprueba por la prioridad si la trama pertenece al mensaje
   
      d(j)=R(j, 11); % Guardamos los datos en el vector 
      
      t(j)=R(j, 15); % Guardamos el tiempo en el vector
      
      else % Si no coincide la prioridad eliminamos los elementos de los vectores
          
         d(d==0)=[];
      
        t(t==0)=[];
      
      end
  end
  
hold on % Mantenemos la gráfica de traffic para representar la señal encima

figure(1); % Aseguramos que siempre se represente en la ventana figure 1

plot (t, d,'r')  % Representamos gráficamente los datos deseados
   

