% recibir despacha los mensajes en orden de llegada y según su prioridad

function R = recibir (prioridad)

load variables3; % Cargamos la matriz A

load variables; % Cargamos T

ti = A(1,15); % Inicializamos ti, que usaremos para iniciar el tiempo desde el que se empieza a recibir

tf = T; % Inicializamos tf, el tiempo final hasta el que se compara

tt = 1.5e-04; % Definimos el tiempo de trama

tr = A(1,15) + tt; % Inicializamos el tiempo de recepción

R(size(A,1),15) = zeros; % Inicializo la matriz en la que introduciré todas las filas ordenadas


  b=0; % Inicializo b para contar el numero de mensajes dentro de un intervalo
  
  c=0; % Inicializo c, que contará la posición a partir de la que se debe seguir rellenando R 
    
  B=[]; % Definimos la matriz B, desde donde se despachan las tramas antes de colocarlas en R
  
  
  while (size(A,1) ~= size(B,1)) % Bucle que evita el error cuando A disminuye
     
          
    if (A((b+1),15) <= tf)  % Bucle para buscar las tramas que se transmiten en un intervalo de tiempo
        
        b=b+1 % Si es así incrementamos b, hasta contar el número de mensajes en dicho intervalo
        
               
    else
        
                  
            if (b==0)  % Evita un error de dimensiones
                
        
                  
        else
        
        B(b,15) = zeros; % Definimos las dimensiones de B con b
               
        for r=1:b
            
        B(r,:) =  A(r,:);      % Rellenamos B con los datos correspondientes de A
        
        end       
        
               
        [x,y] = max(B(:,4));    % Obtenemos la fila con más prioridad de B
        
        
        while ((B(y,15))>tr)   % Si el tiempo de esta fila es menor que el de recepcion podemos recibirla
            
        tr=tr+ti;   % Actualizamos tr    
        
        end           
        
                  
        B(y,15)= tr + tt; % La despachamos en B
                                            
        c=c+1;  % Actualizamos c, que es la posicion a partir de la cual tenemos que rellenar R
        
        
        R((c),:) = B(y,:);  % Introducimos en R esta fila
                             
        A(y,:)=[]; % Borramos la fila de A
                 
        b=0; % Volvemos a inicializar b para la siguiente ejecución del bucle
        
        tr=tr+ti; % Actualizamos tr
        
        end
                    
                         
        tf=tf+T;    % Actualizamos tf     
        
            end
                    
         
  end
  
  while (size(B,1)>0) % Cuando todas las tramas están en B, las tomamos directamente de aquí
  
        [x,y] = max(B(:,4));    % Obtenemos la fila con más prioridad de B
        
        
        while ((B(y,15))>tr)   % Si el tiempo de esta fila es menor que el de recepción podemos recibirla
            
        tr=tr+ti; % Actualizamos tr    
        
        end           
        
                  
        B(y,15)=tr+tt; % La despachamos en B
                                            
        c=c+1;  % Actualizamos c, que es la posicion a partir de la cual tenemos que rellenar R
                
        R((c),:) = B(y,:);  % Introducimos en R esta fila
                             
        B(y,:)=[]; % Borramos la fila de B
                         
        tr=tr+ti; % Actualizamos tr
        
        tf=tf+T;    % Actualizamos tf     
        
  end
  
% Para representar gráficamente R:

  d=[]; % Definimos el vector que portará los datos
  
  t=[]; % Definimos el vector que portará el tiempo
  
  
  for j=1:size(R,1)  % Recorremos la matriz para ir rellenando los vectores:
  
       
      if (R(j,4)==prioridad) % Se comprueba por la prioridad si la trama pertenece al mensaje
   
      d(j)=R(j, 11); % Guardamos los datos en el vector 
      
      t(j)=R(j, 15); % Guardamos el tiempo en el vector
      
      else % Si no coincide la prioridad eliminamos los elementos de los vectores
          
         d(d==0)=[];
      
        t(t==0)=[];
      
      end
  end
  
hold on % Mantenemos la gráfica de traffic para representar la señal encima

figure(1); % Aseguramos que siempre se represente en la ventana figure 1

plot (t, d,'r')  % Representamos gráficamente los datos deseados
   
  